/*
[GLOBAL _GrInitialize]
[GLOBAL _GrShutdown]
[GLOBAL _GrRefresh]
[GLOBAL _GrGetSlotMap]
[GLOBAL _GrGetClassMap]
[GLOBAL _GrGetOEMClassMap]
[GLOBAL _GrGetMaxIndex]
[GLOBAL _GrGetMaxValue]
[GLOBAL _GrGetValue]
[GLOBAL _GrGetPackedValues]
[GLOBAL _GrSetValue]
[GLOBAL _GrGetVendorName]
[GLOBAL _GrGetProductName]
[GLOBAL _GrGetControlName]
[GLOBAL _GrGetCaps]
[GLOBAL _Gr__Link]
[GLOBAL _Gr__Unlink]
[GLOBAL _GrGetSWVer]
[GLOBAL _GrGetHWVer]
[GLOBAL _GrGetDiagCnt]
[GLOBAL _GrGetDiagReg]
[GLOBAL _DPMI_SetCodeAR]
[GLOBAL _DPMI_SetDataAR]

[EXTERN _GRIP_Thunk]
*/

/*#include "../i386/asmdefs.inc"*/

.extern _GRIP_Thunk

.text


#define _align_   .balign 4, 0x90
#define FUNC(name)            .globl name ; _align_ ; name:


#define GRIP_CALL             lcall _GRIP_Thunk + 8

/*
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Since I don't know which registers DJGPP wants preserved, I've decided to ;;
;; save all registers that get modified, except for EAX when the function    ;;
;; returns a value. Better safe than sorry, says me.                         ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
*/

FUNC(_GrInitialize)
	movw	$0x84A1,%ax
	GRIP_CALL
ret

FUNC(_GrShutdown)
	pushl	%eax
	movw	$0x84A2,%ax
	GRIP_CALL
	popl %eax
ret

FUNC(_GrRefresh)
	pushl	%ebp
	movl	%esp,%ebp
	pushl 	%edx

	movl 	8(%ebp), %edx

	movw	$0x84A0,%ax
	GRIP_CALL

	popl 	%edx
	popl 	%ebp
ret

FUNC(_GrGetSlotMap)
	movw	$0x84B0,%ax
	GRIP_CALL
ret

FUNC(_GrGetClassMap)
	pushl	%ebp
	movl	%esp,%ebp
	pushl	%ebx

	movb	8(%ebp), %bh

	movw	$0x84B1,%ax
	GRIP_CALL

	popl 	%ebx
	popl 	%ebp
ret

FUNC(_GrGetOEMClassMap)
	pushl	%ebp
	movl	%esp,%ebp
	pushl	%ebx

	movb	8(%ebp),%bh

	movw	$0x84B2,%ax
	GRIP_CALL

	popl 	%ebx
	popl 	%ebp
ret

FUNC(_GrGetMaxIndex)
	pushl	%ebp
	movl	%esp,%ebp
	pushl	%ebx

	movb	8(%ebp),%bh
	movb	12(%ebp),%bl

	movw	$0x84B3,%ax
	GRIP_CALL

	popl	%ebx
	popl	%ebp
ret

FUNC(_GrGetMaxValue)
	pushl	%ebp
	movl	%esp,%ebp

	movb	8(%ebp),%bh
	movb	12(%ebp),%bl

	movw	$0x84B4,%ax
	GRIP_CALL

	popl	%ebp
ret

FUNC(_GrGetValue)
	pushl	%ebp
	movl	%esp,%ebp
	pushl	%ebx
	pushl	%ecx

	movb	8(%ebp),%bh
	movb	12(%ebp),%bl
	movb	16(%ebp),%ch

	movw	$0x84C0,%ax
	GRIP_CALL

	popl	%ecx
	popl	%ebx
	popl	%ebp
ret

FUNC(_GrGetPackedValues)
	pushl	%ebp
	movl	%esp,%ebp
	pushl	%ebx
	pushl	%ecx

	movb	8(%ebp),%bh
	movb	12(%ebp),%bl
	movb	16(%ebp),%ch
	movb	20(%ebp),%cl

	movw	$0x84C1,%ax
	GRIP_CALL

	popl	%ecx
	popl	%ebx
	popl	%ebp
ret

FUNC(_GrSetValue)
	pushl	%ebp
	movl	%esp,%ebp
	pushl	%eax
	pushl	%ebx
	pushl	%ecx
	pushl	%edx

	movb	8(%ebp),%bh
	movb	12(%ebp),%bl
	movb	16(%ebp),%ch
	movw	20(%ebp),%dx

	movw	$0x84C2,%ax
	GRIP_CALL

	popl	%edx
	popl	%ecx
	popl	%ebx
	popl	%eax
	popl	%ebp
ret

FUNC(_GrGetVendorName)
	pushl	%ebp
	movl	%esp,%ebp
	pushl	%esi
	pushl	%edi
	pushl	%eax
	pushl	%ebx
	pushl	%ecx
	pushl	%edx

	movb	8(%ebp),%bh
	movl	12(%ebp),%edi

	movw	$0x84D0,%ax
	GRIP_CALL

	movl	%ebx,0x00(%edi)
	movl	%ecx,0x04(%edi)
	movl	%edx,0x08(%edi)
	movl	%esi,0x0C(%edi)

	popl	%edx
	popl	%ecx
	popl	%ebx
	popl	%eax
	popl	%edi
	popl	%esi
	popl	%ebp
ret

FUNC(_GrGetProductName)
	pushl	%ebp
	movl	%esp,%ebp
	pushl	%esi
	pushl	%edi
	pushl	%ebx
	pushl	%ecx
	pushl	%edx

	movb	8(%ebp),%bh
	movl	12(%ebp),%edi

	movw	$0x84D1,%ax
	GRIP_CALL

	movl	%ebx,0x00(%edi)
	movl	%ecx,0x04(%edi)
	movl	%edx,0x08(%edi)
	movl	%esi,0x0C(%edi)

	popl	%edx
	popl	%ecx
	popl	%ebx
	popl	%edi
	popl	%esi
	popl	%ebp
ret

FUNC(_GrGetControlName)
	pushl	%ebp
	movl	%esp,%ebp
	pushl	%esi
	pushl	%edi
	pushl	%eax
	pushl	%ebx
	pushl	%ecx
	pushl	%edx

	movb	8(%ebp),%bh
	movb	12(%ebp),%bl
	movb	16(%ebp),%ch
	movl	20(%ebp),%edi

	movw	$0x84D2,%ax
	GRIP_CALL
	
	movl	%ebx,0x00(%edi)
	movl	%ecx,0x04(%edi)
	movl	%edx,0x08(%edi)
	movl	%esi,0x0C(%edi)

	popl	%edx
	popl	%ecx
	popl	%ebx
	popl	%eax
	popl	%edi
	popl	%esi
	popl	%ebp
ret

FUNC(_GrGetCaps)
   xorl 	%eax, %eax
ret

FUNC(_Gr__Link)
	movw	$0x8490,%ax
	GRIP_CALL
ret

FUNC(_Gr__Unlink)
	pushl	%eax
	movw	$0x8491,%ax
	GRIP_CALL
	popl	%eax
ret

FUNC(_GrGetSWVer)
	movw	$0x84F0,%ax
	GRIP_CALL
ret

FUNC(_GrGetHWVer)
	movw	$0x84F1,%ax
	GRIP_CALL
ret

FUNC(_GrGetDiagCnt)
	movw	$0x84F2,%ax
	GRIP_CALL
ret

FUNC(_GrGetDiagReg)
	pushl	%ebp
	movl	%esp,%ebp
	pushl	%ebx

	movb	8(%ebp),%bh

	movw	$0x84F3,%ax
	GRIP_CALL

	popl	%ebx
	popl	%ebp
ret

/*
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; These functions call the DPMI host to set access rights for the ;;
;; descriptor whose selector is sent as a parameter.               ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
*/
FUNC(_DPMI_SetCodeAR)
	pushl	%ebp
	movl	%esp,%ebp
	pushl	%ebx
	pushl	%ecx
	pushf	

	movw	8(%ebp),%bx

	movw	%cs,%cx
	larl	%ecx,%ecx
	shrw	$8,%cx
	movl	$0x09,%eax
	int		$0x31
	setcb	%al

	popf	
	popl	%ecx
	popl	%ebx
	popl	%ebp
ret

FUNC(_DPMI_SetDataAR)
	pushl	%ebp
	movl	%esp,%ebp
	pushl	%ebx
	pushl	%ecx
	pushf	

	movw	8(%ebp),%bx

	movw	%ds,%cx
	larl	%ecx,%ecx
	shrw	$8,%cx
	movl	$0x09,%eax
	int		$0x31
	setcb	%al

	popf	
	popl	%ecx
	popl	%ebx
	popl	%ebp
ret

